diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index eb2d33dd86..8a0fcd7ece 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -40,6 +40,7 @@
 #include "catalog/pg_inherits.h"
 #include "catalog/pg_namespace.h"
 #include "catalog/pg_opclass.h"
+#include "catalog/pg_partition.h"
 #include "catalog/pg_tablespace.h"
 #include "catalog/pg_trigger.h"
 #include "catalog/pg_type.h"
@@ -477,6 +478,8 @@ static void RangeVarCallbackForAlterRelation(const RangeVar *rv, Oid relid,
 static PartitionSpec *transformPartitionSpec(Relation rel, PartitionSpec *partspec, char *strategy);
 static void ComputePartitionAttrs(Relation rel, List *partParams, AttrNumber *partattrs,
 					  List **partexprs, Oid *partopclass, Oid *partcollation, char strategy);
+static void AttachPartition(Relation attachrel, Relation rel,
+				PartitionBoundSpec *bound);
 static void CreateInheritance(Relation child_rel, Relation parent_rel);
 static void RemoveInheritance(Relation child_rel, Relation parent_rel);
 static ObjectAddress ATExecAttachPartition(List **wqueue, Relation rel,
@@ -492,8 +495,8 @@ static ObjectAddress ATExecAttachPartitionIdx(List **wqueue, Relation rel,
 static void validatePartitionedIndex(Relation partedIdx, Relation partedTbl);
 static void refuseDupeIndexAttach(Relation parentIdx, Relation partIdx,
 					  Relation partitionTbl);
-static void update_relispartition(Relation classRel, Oid relationId,
-					  bool newval);
+static void update_relpartitionparent(Relation classRel, Oid relationId,
+					  Oid newparent);
 
 
 /* ----------------------------------------------------------------
@@ -771,7 +774,8 @@ DefineRelation(CreateStmt *stmt, char relkind, Oid ownerId,
 										  typaddress);
 
 	/* Store inheritance information for new rel. */
-	StoreCatalogInheritance(relationId, inheritOids, stmt->partbound != NULL);
+	if (stmt->partbound == NULL)
+		StoreCatalogInheritance(relationId, inheritOids, false);
 
 	/*
 	 * We must bump the command counter to make the newly-created relation
@@ -860,8 +864,11 @@ DefineRelation(CreateStmt *stmt, char relkind, Oid ownerId,
 			heap_close(defaultRel, NoLock);
 		}
 
+		/* Add the pg_partition record */
+		AttachPartition(rel, parent, bound);
+
 		/* Update the pg_class entry. */
-		StorePartitionBound(rel, parent, bound);
+		MarkRelationPartitioned(rel, parent, bound->is_default);
 
 		heap_close(parent, NoLock);
 	}
@@ -1204,7 +1211,7 @@ RangeVarCallbackForDropRelation(const RangeVar *rel, Oid relOid, Oid oldRelOid,
 	struct DropRelationCallbackState *state;
 	char		relkind;
 	char		expected_relkind;
-	bool		is_partition;
+	Oid			parentoid;
 	Form_pg_class classform;
 	LOCKMODE	heap_lockmode;
 
@@ -1243,7 +1250,7 @@ RangeVarCallbackForDropRelation(const RangeVar *rel, Oid relOid, Oid oldRelOid,
 	if (!HeapTupleIsValid(tuple))
 		return;					/* concurrently dropped, so nothing to do */
 	classform = (Form_pg_class) GETSTRUCT(tuple);
-	is_partition = classform->relispartition;
+	parentoid = classform->relpartitionparent;
 
 	/*
 	 * Both RELKIND_RELATION and RELKIND_PARTITIONED_TABLE are OBJECT_TABLE,
@@ -1298,11 +1305,10 @@ RangeVarCallbackForDropRelation(const RangeVar *rel, Oid relOid, Oid oldRelOid,
 	 * parent before its partitions, so we risk deadlock it we do it the other
 	 * way around.
 	 */
-	if (is_partition && relOid != oldRelOid)
+	if (OidIsValid(parentoid) && relOid != oldRelOid)
 	{
-		state->partParentOid = get_partition_parent(relOid);
-		if (OidIsValid(state->partParentOid))
-			LockRelationOid(state->partParentOid, AccessExclusiveLock);
+		state->partParentOid = parentoid;
+		LockRelationOid(parentoid, AccessExclusiveLock);
 	}
 }
 
@@ -1356,7 +1362,11 @@ ExecuteTruncate(TruncateStmt *stmt)
 			ListCell   *child;
 			List	   *children;
 
-			children = find_all_inheritors(myrelid, AccessExclusiveLock, NULL);
+			/* partitioned tables cannot have any inheritors */
+			if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+				children = get_partition_descendants(myrelid, AccessExclusiveLock);
+			else
+				children = find_all_inheritors(myrelid, AccessExclusiveLock, NULL);
 
 			foreach(child, children)
 			{
@@ -1972,7 +1982,7 @@ MergeAttributes(List *schema, List *supers, char relpersistence,
 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 					 errmsg("cannot inherit from partitioned table \"%s\"",
 							parent->relname)));
-		if (relation->rd_rel->relispartition && !is_partition)
+		if (OidIsValid(relation->rd_rel->relpartitionparent) && !is_partition)
 			ereport(ERROR,
 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 					 errmsg("cannot inherit from partition \"%s\"",
@@ -2761,28 +2771,45 @@ renameatt_internal(Oid myrelid,
 		ListCell   *lo,
 				   *li;
 
-		/*
-		 * we need the number of parents for each child so that the recursive
-		 * calls to renameatt() can determine whether there are any parents
-		 * outside the inheritance hierarchy being processed.
-		 */
-		child_oids = find_all_inheritors(myrelid, AccessExclusiveLock,
-										 &child_numparents);
+		if (targetrelation->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+		{
+			child_oids = get_partition_descendants(myrelid, AccessExclusiveLock);
 
-		/*
-		 * find_all_inheritors does the recursive search of the inheritance
-		 * hierarchy, so all we have to do is process all of the relids in the
-		 * list that it returns.
-		 */
-		forboth(lo, child_oids, li, child_numparents)
+			foreach(lo, child_oids)
+			{
+				Oid			childrelid = lfirst_oid(lo);
+
+				if (childrelid == myrelid)
+					continue;
+				/* note we need not recurse again */
+				renameatt_internal(childrelid, oldattname, newattname, false, true, 1, behavior);
+			}
+		}
+		else if (!OidIsValid(targetrelation->rd_rel->relpartitionparent))
 		{
-			Oid			childrelid = lfirst_oid(lo);
-			int			numparents = lfirst_int(li);
+			/*
+			 * we need the number of parents for each child so that the recursive
+			 * calls to renameatt() can determine whether there are any parents
+			 * outside the inheritance hierarchy being processed.
+			 */
+			child_oids = find_all_inheritors(myrelid, AccessExclusiveLock,
+											 &child_numparents);
 
-			if (childrelid == myrelid)
-				continue;
-			/* note we need not recurse again */
-			renameatt_internal(childrelid, oldattname, newattname, false, true, numparents, behavior);
+			/*
+			 * find_all_inheritors does the recursive search of the inheritance
+			 * hierarchy, so all we have to do is process all of the relids in the
+			 * list that it returns.
+			 */
+			forboth(lo, child_oids, li, child_numparents)
+			{
+				Oid			childrelid = lfirst_oid(lo);
+				int			numparents = lfirst_int(li);
+
+				if (childrelid == myrelid)
+					continue;
+				/* note we need not recurse again */
+				renameatt_internal(childrelid, oldattname, newattname, false, true, numparents, behavior);
+			}
 		}
 	}
 	else
@@ -5043,12 +5070,17 @@ ATSimpleRecursion(List **wqueue, Relation rel,
 		ListCell   *child;
 		List	   *children;
 
-		children = find_all_inheritors(relid, lockmode, NULL);
+		if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+			children = get_partition_descendants(relid, lockmode);
+		else if (!OidIsValid(rel->rd_rel->relpartitionparent))
+			children = find_all_inheritors(relid, lockmode, NULL);
+		else
+			children = NIL;
 
 		/*
-		 * find_all_inheritors does the recursive search of the inheritance
-		 * hierarchy, so all we have to do is process all of the relids in the
-		 * list that it returns.
+		 * find_all_inheritors and get_partition_descendants performs the
+		 * recursive search for all descendant tables, so all we have to do is
+		 * process all of the relids in the list that it returns.
 		 */
 		foreach(child, children)
 		{
@@ -5057,7 +5089,7 @@ ATSimpleRecursion(List **wqueue, Relation rel,
 
 			if (childrelid == relid)
 				continue;
-			/* find_all_inheritors already got lock */
+			/* lock already obtained above */
 			childrel = relation_open(childrelid, NoLock);
 			CheckTableNotInUse(childrel, "ALTER TABLE");
 			ATPrepCmd(wqueue, childrel, cmd, false, true, lockmode);
@@ -5374,7 +5406,7 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	if (recursing)
 		ATSimplePermissions(rel, ATT_TABLE | ATT_FOREIGN_TABLE);
 
-	if (rel->rd_rel->relispartition && !recursing)
+	if (OidIsValid(rel->rd_rel->relpartitionparent) && !recursing)
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 				 errmsg("cannot add column to a partition")));
@@ -5697,7 +5729,18 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	 * routines, we have to do this one level of recursion at a time; we can't
 	 * use find_all_inheritors to do it in one pass.
 	 */
-	children = find_inheritance_children(RelationGetRelid(rel), lockmode);
+	if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+	{
+		PartitionDesc partdesc = RelationGetPartitionDesc(rel);
+		int i;
+		children = NIL;
+		for (i = 0; i < partdesc->nparts; i++)
+			children = lappend_oid(children, partdesc->oids[i]);
+	}
+	else if (OidIsValid(rel->rd_rel->relpartitionparent))
+		children = NIL;
+	else
+		children = find_inheritance_children(RelationGetRelid(rel), lockmode);
 
 	/*
 	 * If we are told not to recurse, there had better not be any child
@@ -5971,10 +6014,13 @@ ATExecDropNotNull(Relation rel, const char *colName, LOCKMODE lockmode)
 
 	list_free(indexoidlist);
 
-	/* If rel is partition, shouldn't drop NOT NULL if parent has the same */
-	if (rel->rd_rel->relispartition)
+	/*
+	 * Disallow dropping of partitions NOT NULL constraints when the
+	 * constraint is present on the parent.
+	 */
+	if (OidIsValid(RelationGetParentRelid(rel)))
 	{
-		Oid			parentId = get_partition_parent(RelationGetRelid(rel));
+		Oid			parentId = RelationGetParentRelid(rel);
 		Relation	parent = heap_open(parentId, AccessShareLock);
 		TupleDesc	tupDesc = RelationGetDescr(parent);
 		AttrNumber	parent_attnum;
@@ -6800,7 +6846,21 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 	 * routines, we have to do this one level of recursion at a time; we can't
 	 * use find_all_inheritors to do it in one pass.
 	 */
-	children = find_inheritance_children(RelationGetRelid(rel), lockmode);
+	if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+	{
+		PartitionDesc partdesc = RelationGetPartitionDesc(rel);
+		int i;
+		children = NIL;
+		for (i = 0; i < partdesc->nparts; i++)
+		{
+			LockRelationOid(partdesc->oids[i], lockmode);
+			children = lappend_int(children, partdesc->oids[i]);
+		}
+	}
+	else if (!OidIsValid(rel->rd_rel->relpartitionparent))
+		children = find_inheritance_children(RelationGetRelid(rel), lockmode);
+	else
+		children = NIL;
 
 	if (children)
 	{
@@ -7251,7 +7311,21 @@ ATAddCheckConstraint(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	 * routines, we have to do this one level of recursion at a time; we can't
 	 * use find_all_inheritors to do it in one pass.
 	 */
-	children = find_inheritance_children(RelationGetRelid(rel), lockmode);
+	if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+	{
+		PartitionDesc partdesc = RelationGetPartitionDesc(rel);
+		int i;
+		children = NIL;
+		for (i = 0; i < partdesc->nparts; i++)
+		{
+			LockRelationOid(partdesc->oids[i], lockmode);
+			children = lappend_int(children, partdesc->oids[i]);
+		}
+	}
+	else if (!OidIsValid(rel->rd_rel->relpartitionparent))
+		children = find_inheritance_children(RelationGetRelid(rel), lockmode);
+	else
+		children = NIL;
 
 	/*
 	 * Check if ONLY was specified with ALTER TABLE.  If so, allow the
@@ -8025,8 +8099,14 @@ ATExecValidateConstraint(Relation rel, char *constrName, bool recurse,
 			 * shouldn't try to look for it in the children.
 			 */
 			if (!recursing && !con->connoinherit)
-				children = find_all_inheritors(RelationGetRelid(rel),
+			{
+				if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+					children = get_partition_descendants(RelationGetRelid(rel),
+														 lockmode);
+				else if (!OidIsValid(rel->rd_rel->relpartitionparent))
+					children = find_all_inheritors(RelationGetRelid(rel),
 											   lockmode, NULL);
+			}
 
 			/*
 			 * For CHECK constraints, we must ensure that we only mark the
@@ -8939,7 +9019,23 @@ ATExecDropConstraint(Relation rel, const char *constrName,
 	 * use find_all_inheritors to do it in one pass.
 	 */
 	if (!is_no_inherit_constraint)
-		children = find_inheritance_children(RelationGetRelid(rel), lockmode);
+	{
+		if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+		{
+			PartitionDesc partdesc = RelationGetPartitionDesc(rel);
+			int i;
+			children = NIL;
+			for (i = 0; i < partdesc->nparts; i++)
+			{
+				LockRelationOid(partdesc->oids[i], lockmode);
+				children = lappend_int(children, partdesc->oids[i]);
+			}
+		}
+		else if (!OidIsValid(rel->rd_rel->relpartitionparent))
+			children = find_inheritance_children(RelationGetRelid(rel), lockmode);
+		else
+			children = NIL;
+	}
 	else
 		children = NIL;
 
@@ -9230,12 +9326,15 @@ ATPrepAlterColumnType(List **wqueue,
 		ListCell   *child;
 		List	   *children;
 
-		children = find_all_inheritors(relid, lockmode, NULL);
+		if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+			children = get_partition_descendants(relid, lockmode);
+		else
+			children = find_all_inheritors(relid, lockmode, NULL);
 
 		/*
-		 * find_all_inheritors does the recursive search of the inheritance
-		 * hierarchy, so all we have to do is process all of the relids in the
-		 * list that it returns.
+		 * find_all_inheritors and get_partition_descendants does the
+		 * recursive search of all descendants tables, so all we have to do is
+		 * process all of the relids in the list that it returns.
 		 */
 		foreach(child, children)
 		{
@@ -9245,7 +9344,7 @@ ATPrepAlterColumnType(List **wqueue,
 			if (childrelid == relid)
 				continue;
 
-			/* find_all_inheritors already got lock */
+			/* lock already obtained above */
 			childrel = relation_open(childrelid, NoLock);
 			CheckTableNotInUse(childrel, "ALTER TABLE");
 
@@ -11379,7 +11478,7 @@ ATPrepAddInherit(Relation child_rel)
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 				 errmsg("cannot change inheritance of typed table")));
 
-	if (child_rel->rd_rel->relispartition)
+	if (OidIsValid(child_rel->rd_rel->relpartitionparent))
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 				 errmsg("cannot change inheritance of a partition")));
@@ -11443,7 +11542,7 @@ ATExecAddInherit(Relation child_rel, RangeVar *parent, LOCKMODE lockmode)
 						parent->relname)));
 
 	/* Likewise for partitions */
-	if (parent_rel->rd_rel->relispartition)
+	if (OidIsValid(parent_rel->rd_rel->relpartitionparent))
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 				 errmsg("cannot inherit from a partition")));
@@ -11506,6 +11605,59 @@ ATExecAddInherit(Relation child_rel, RangeVar *parent, LOCKMODE lockmode)
 	return address;
 }
 
+static void
+AttachPartition(Relation attachrel, Relation rel, PartitionBoundSpec *bound)
+{
+	Datum		values[Natts_pg_partition];
+	bool		nulls[Natts_pg_partition];
+	HeapTuple	tuple;
+	Relation	partRelation;
+	Oid			attachrelid = RelationGetRelid(attachrel);
+	Oid			partedrelid = RelationGetRelid(rel);
+	ObjectAddress childobject,
+				parentobject;
+
+	partRelation = heap_open(PartitionRelationId, RowExclusiveLock);
+
+	/*
+	 * Make the pg_partition entry
+	 */
+	values[Anum_pg_partition_partrelid - 1] = ObjectIdGetDatum(attachrelid);
+	values[Anum_pg_partition_parentrelid - 1] = ObjectIdGetDatum(partedrelid);
+	values[Anum_pg_partition_partbound - 1] = CStringGetTextDatum(nodeToString(bound));
+
+	memset(nulls, 0, sizeof(nulls));
+
+	tuple = heap_form_tuple(RelationGetDescr(partRelation), values, nulls);
+
+	CatalogTupleInsert(partRelation, tuple);
+
+	heap_freetuple(tuple);
+
+	heap_close(partRelation, RowExclusiveLock);
+
+	/*
+	 * Store a dependency too
+	 */
+	parentobject.classId = RelationRelationId;
+	parentobject.objectId = partedrelid;
+	parentobject.objectSubId = 0;
+	childobject.classId = RelationRelationId;
+	childobject.objectId = attachrelid;
+	childobject.objectSubId = 0;
+
+	recordDependencyOn(&childobject, &parentobject, DEPENDENCY_AUTO);
+
+	/*
+	 * Post creation hook of this partition. Since object_access_hook
+	 * doesn't take multiple object identifiers, we relay oid of parent
+	 * relation using auxiliary_id argument.
+	 */
+	InvokeObjectPostAlterHookArg(PartitionRelationId,
+								 attachrelid, 0,
+								 partedrelid, false);
+}
+
 /*
  * CreateInheritance
  *		Catalog manipulation portion of creating inheritance between a child
@@ -11922,7 +12074,7 @@ ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
 	ObjectAddress address;
 	Relation	parent_rel;
 
-	if (rel->rd_rel->relispartition)
+	if (OidIsValid(rel->rd_rel->relpartitionparent))
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 				 errmsg("cannot change inheritance of a partition")));
@@ -11967,7 +12119,7 @@ ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
  * coninhcount and conislocal for inherited constraints are adjusted in
  * exactly the same way.
  *
- * Common to ATExecDropInherit() and ATExecDetachPartition().
+ * Used in ATExecDropInherit()
  */
 static void
 RemoveInheritance(Relation child_rel, Relation parent_rel)
@@ -11979,28 +12131,16 @@ RemoveInheritance(Relation child_rel, Relation parent_rel)
 				constraintTuple;
 	List	   *connames;
 	bool		found;
-	bool		child_is_partition = false;
-
-	/* If parent_rel is a partitioned table, child_rel must be a partition */
-	if (parent_rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
-		child_is_partition = true;
 
 	found = DeleteInheritsTuple(RelationGetRelid(child_rel),
 								RelationGetRelid(parent_rel));
 	if (!found)
 	{
-		if (child_is_partition)
-			ereport(ERROR,
-					(errcode(ERRCODE_UNDEFINED_TABLE),
-					 errmsg("relation \"%s\" is not a partition of relation \"%s\"",
-							RelationGetRelationName(child_rel),
-							RelationGetRelationName(parent_rel))));
-		else
-			ereport(ERROR,
-					(errcode(ERRCODE_UNDEFINED_TABLE),
-					 errmsg("relation \"%s\" is not a parent of relation \"%s\"",
-							RelationGetRelationName(parent_rel),
-							RelationGetRelationName(child_rel))));
+		ereport(ERROR,
+				(errcode(ERRCODE_UNDEFINED_TABLE),
+					errmsg("relation \"%s\" is not a parent of relation \"%s\"",
+						RelationGetRelationName(parent_rel),
+						RelationGetRelationName(child_rel))));
 	}
 
 	/*
@@ -12119,7 +12259,7 @@ RemoveInheritance(Relation child_rel, Relation parent_rel)
 	drop_parent_dependency(RelationGetRelid(child_rel),
 						   RelationRelationId,
 						   RelationGetRelid(parent_rel),
-						   child_dependency_type(child_is_partition));
+						   child_dependency_type(false));
 
 	/*
 	 * Post alter hook of this inherits. Since object_access_hook doesn't take
@@ -14039,7 +14179,6 @@ ATExecAttachPartition(List **wqueue, Relation rel, PartitionCmd *cmd)
 {
 	Relation	attachrel,
 				catalog;
-	List	   *attachrel_children;
 	List	   *partConstraint;
 	SysScanDesc scan;
 	ScanKeyData skey;
@@ -14072,7 +14211,7 @@ ATExecAttachPartition(List **wqueue, Relation rel, PartitionCmd *cmd)
 	ATSimplePermissions(attachrel, ATT_TABLE | ATT_FOREIGN_TABLE);
 
 	/* A partition can only have one parent */
-	if (attachrel->rd_rel->relispartition)
+	if (OidIsValid(attachrel->rd_rel->relpartitionparent))
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 				 errmsg("\"%s\" is already a partition",
@@ -14084,8 +14223,8 @@ ATExecAttachPartition(List **wqueue, Relation rel, PartitionCmd *cmd)
 				 errmsg("cannot attach a typed table as partition")));
 
 	/*
-	 * Table being attached should not already be part of inheritance; either
-	 * as a child table...
+	 * The table being attached should not be part of any inheritance
+	 * hierarchy as a child or as a parent.
 	 */
 	catalog = heap_open(InheritsRelationId, AccessShareLock);
 	ScanKeyInit(&skey,
@@ -14100,15 +14239,13 @@ ATExecAttachPartition(List **wqueue, Relation rel, PartitionCmd *cmd)
 				 errmsg("cannot attach inheritance child as partition")));
 	systable_endscan(scan);
 
-	/* ...or as a parent table (except the case when it is partitioned) */
 	ScanKeyInit(&skey,
 				Anum_pg_inherits_inhparent,
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(RelationGetRelid(attachrel)));
 	scan = systable_beginscan(catalog, InheritsParentIndexId, true, NULL,
 							  1, &skey);
-	if (HeapTupleIsValid(systable_getnext(scan)) &&
-		attachrel->rd_rel->relkind == RELKIND_RELATION)
+	if (HeapTupleIsValid(systable_getnext(scan)))
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 				 errmsg("cannot attach inheritance parent as partition")));
@@ -14129,16 +14266,24 @@ ATExecAttachPartition(List **wqueue, Relation rel, PartitionCmd *cmd)
 	 * definition is present in all the partitions, we need not scan the
 	 * table, nor its partitions.  But we cannot risk a deadlock by taking a
 	 * weaker lock now and the stronger one only when needed.
+	 *
+	 * The the attachrel is a leaf partition, then it can have no partitions
+	 * so we needn't bother checking this.
 	 */
-	attachrel_children = find_all_inheritors(RelationGetRelid(attachrel),
-											 AccessExclusiveLock, NULL);
-	if (list_member_oid(attachrel_children, RelationGetRelid(rel)))
-		ereport(ERROR,
-				(errcode(ERRCODE_DUPLICATE_TABLE),
-				 errmsg("circular inheritance not allowed"),
-				 errdetail("\"%s\" is already a child of \"%s\".",
-						   RelationGetRelationName(rel),
-						   RelationGetRelationName(attachrel))));
+	if (attachrel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
+	{
+		List	   *attachrel_children;
+
+		attachrel_children = get_partition_descendants(RelationGetRelid(attachrel),
+													   AccessExclusiveLock);
+		if (list_member_oid(attachrel_children, RelationGetRelid(rel)))
+			ereport(ERROR,
+					(errcode(ERRCODE_DUPLICATE_TABLE),
+					 errmsg("circular partitioning is not allowed"),
+					 errdetail("\"%s\" is already a child of \"%s\".",
+							   RelationGetRelationName(rel),
+							   RelationGetRelationName(attachrel))));
+	}
 
 	/* If the parent is permanent, so must be all of its partitions. */
 	if (rel->rd_rel->relpersistence != RELPERSISTENCE_TEMP &&
@@ -14223,8 +14368,11 @@ ATExecAttachPartition(List **wqueue, Relation rel, PartitionCmd *cmd)
 						trigger_name, RelationGetRelationName(attachrel)),
 				 errdetail("ROW triggers with transition tables are not supported on partitions")));
 
-	/* OK to create inheritance.  Rest of the checks performed there */
-	CreateInheritance(attachrel, rel);
+	/* Match up the columns and bump attinhcount as needed */
+	MergeAttributesIntoExisting(attachrel, rel);
+
+	/* Match up the constraints and bump coninhcount as needed */
+	MergeConstraintsIntoExisting(attachrel, rel);
 
 	/*
 	 * Check that the new partition's bound is valid and does not overlap any
@@ -14234,8 +14382,10 @@ ATExecAttachPartition(List **wqueue, Relation rel, PartitionCmd *cmd)
 	check_new_partition_bound(RelationGetRelationName(attachrel), rel,
 							  cmd->bound);
 
+	AttachPartition(attachrel, rel, cmd->bound);
+
 	/* Update the pg_class entry. */
-	StorePartitionBound(attachrel, rel, cmd->bound);
+	MarkRelationPartitioned(attachrel, rel, cmd->bound->is_default);
 
 	/* Ensure there exists a correct set of indexes in the partition. */
 	AttachPartitionEnsureIndexes(rel, attachrel);
@@ -14427,7 +14577,7 @@ AttachPartitionEnsureIndexes(Relation rel, Relation attachrel)
 			Oid			cldConstrOid = InvalidOid;
 
 			/* does this index have a parent?  if so, can't use it */
-			if (attachrelIdxRels[i]->rd_rel->relispartition)
+			if (OidIsValid(attachrelIdxRels[i]->rd_rel->relpartitionparent))
 				continue;
 
 			if (CompareIndexInfo(attachInfos[i], info,
@@ -14458,7 +14608,7 @@ AttachPartitionEnsureIndexes(Relation rel, Relation attachrel)
 				IndexSetParentIndex(attachrelIdxRels[i], idx);
 				if (OidIsValid(constraintOid))
 					ConstraintSetParentConstraint(cldConstrOid, constraintOid);
-				update_relispartition(NULL, cldIdxId, true);
+				update_relpartitionparent(NULL, cldIdxId, idx);
 				found = true;
 				break;
 			}
@@ -14628,18 +14778,20 @@ static ObjectAddress
 ATExecDetachPartition(Relation rel, RangeVar *name)
 {
 	Relation	partRel,
-				classRel;
-	HeapTuple	tuple,
-				newtuple;
-	Datum		new_val[Natts_pg_class];
-	bool		isnull,
-				new_null[Natts_pg_class],
-				new_repl[Natts_pg_class];
+				pgclass,
+				pgattr,
+				pgpart;
+	HeapTuple	tuple;
+	HeapTuple	parttup;
+	bool		isnull;
+	SysScanDesc scan;
+	ScanKeyData key[3];
 	ObjectAddress address;
 	Oid			defaultPartOid;
 	List	   *indexes;
 	ListCell   *cell;
 
+
 	/*
 	 * We must lock the default partition, because detaching this partition
 	 * will change its partition constraint.
@@ -14651,35 +14803,85 @@ ATExecDetachPartition(Relation rel, RangeVar *name)
 
 	partRel = heap_openrv(name, AccessShareLock);
 
-	/* All inheritance related checks are performed within the function */
-	RemoveInheritance(partRel, rel);
-
 	/* Update pg_class tuple */
-	classRel = heap_open(RelationRelationId, RowExclusiveLock);
+	pgclass = heap_open(RelationRelationId, RowExclusiveLock);
 	tuple = SearchSysCacheCopy1(RELOID,
 								ObjectIdGetDatum(RelationGetRelid(partRel)));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u",
 			 RelationGetRelid(partRel));
-	Assert(((Form_pg_class) GETSTRUCT(tuple))->relispartition);
 
-	(void) SysCacheGetAttr(RELOID, tuple, Anum_pg_class_relpartbound,
+	if (!OidIsValid(((Form_pg_class) GETSTRUCT(tuple))->relpartitionparent))
+		ereport(ERROR,
+				(errcode(ERRCODE_UNDEFINED_TABLE),
+					errmsg("relation \"%s\" is not a partition of relation \"%s\"",
+						RelationGetRelationName(partRel),
+						RelationGetRelationName(rel))));
+
+	pgpart = heap_open(PartitionRelationId, RowExclusiveLock);
+
+	parttup = SearchSysCacheCopy1(PARTSRELID,
+								  ObjectIdGetDatum(RelationGetRelid(partRel)));
+	if (!HeapTupleIsValid(parttup))
+		elog(ERROR, "cache lookup failed for relation %u",
+			 RelationGetRelid(partRel));
+	/* XXX or use relpartitionparent to check? */
+	if (((Form_pg_partition) GETSTRUCT(parttup))->parentrelid != RelationGetRelid(rel))
+		ereport(ERROR,
+				(errcode(ERRCODE_UNDEFINED_TABLE),
+					errmsg("relation \"%s\" is not a partition of relation \"%s\"",
+						RelationGetRelationName(partRel),
+						RelationGetRelationName(rel))));
+
+	(void) SysCacheGetAttr(PARTSRELID, parttup, Anum_pg_partition_partbound,
 						   &isnull);
 	Assert(!isnull);
 
-	/* Clear relpartbound and reset relispartition */
-	memset(new_val, 0, sizeof(new_val));
-	memset(new_null, false, sizeof(new_null));
-	memset(new_repl, false, sizeof(new_repl));
-	new_val[Anum_pg_class_relpartbound - 1] = (Datum) 0;
-	new_null[Anum_pg_class_relpartbound - 1] = true;
-	new_repl[Anum_pg_class_relpartbound - 1] = true;
-	newtuple = heap_modify_tuple(tuple, RelationGetDescr(classRel),
-								 new_val, new_null, new_repl);
-
-	((Form_pg_class) GETSTRUCT(newtuple))->relispartition = false;
-	CatalogTupleUpdate(classRel, &newtuple->t_self, newtuple);
-	heap_freetuple(newtuple);
+	/* unset relpartitionparent */
+	((Form_pg_class) GETSTRUCT(tuple))->relpartitionparent = InvalidOid;
+	CatalogTupleUpdate(pgclass, &tuple->t_self, tuple);
+	heap_freetuple(tuple);
+
+	CatalogTupleDelete(pgpart, &parttup->t_self);
+	heap_freetuple(parttup);
+
+	/*
+	 * Search through child columns looking for ones matching parent partition
+	 */
+	pgattr = heap_open(AttributeRelationId, RowExclusiveLock);
+	ScanKeyInit(&key[0],
+				Anum_pg_attribute_attrelid,
+				BTEqualStrategyNumber, F_OIDEQ,
+				ObjectIdGetDatum(RelationGetRelid(partRel)));
+	scan = systable_beginscan(pgattr, AttributeRelidNumIndexId,
+							  true, NULL, 1, key);
+	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
+	{
+		Form_pg_attribute att = (Form_pg_attribute) GETSTRUCT(tuple);
+
+		/* Ignore if dropped or not inherited */
+		if (att->attisdropped)
+			continue;
+		if (att->attinhcount <= 0)
+			continue;
+
+		if (SearchSysCacheExistsAttName(RelationGetRelid(rel),
+										NameStr(att->attname)))
+		{
+			/* Decrement inhcount and possibly set islocal to true */
+			HeapTuple	copyTuple = heap_copytuple(tuple);
+			Form_pg_attribute copy_att = (Form_pg_attribute) GETSTRUCT(copyTuple);
+
+			copy_att->attinhcount--;
+			if (copy_att->attinhcount == 0)
+				copy_att->attislocal = true;
+
+			CatalogTupleUpdate(pgattr, &copyTuple->t_self, copyTuple);
+			heap_freetuple(copyTuple);
+		}
+	}
+	systable_endscan(scan);
+	heap_close(pgattr, RowExclusiveLock);
 
 	if (OidIsValid(defaultPartOid))
 	{
@@ -14712,10 +14914,11 @@ ATExecDetachPartition(Relation rel, RangeVar *name)
 
 		idx = index_open(idxid, AccessExclusiveLock);
 		IndexSetParentIndex(idx, InvalidOid);
-		update_relispartition(classRel, idxid, false);
+		update_relpartitionparent(pgclass, idxid, InvalidOid);
 		relation_close(idx, AccessExclusiveLock);
 	}
-	heap_close(classRel, RowExclusiveLock);
+	heap_close(pgclass, RowExclusiveLock);
+	heap_close(pgpart, RowExclusiveLock);
 
 	/*
 	 * Invalidate the parent's relcache so that the partition is no longer
@@ -14728,6 +14931,20 @@ ATExecDetachPartition(Relation rel, RangeVar *name)
 	/* keep our lock until commit */
 	heap_close(partRel, NoLock);
 
+	drop_parent_dependency(RelationGetRelid(partRel),
+						   RelationRelationId,
+						   RelationGetRelid(rel),
+						   child_dependency_type(true));
+
+	/*
+	 * Post alter hook of this inherits. Since object_access_hook doesn't take
+	 * multiple object identifiers, we relay oid of parent relation using
+	 * auxiliary_id argument.
+	 */
+	InvokeObjectPostAlterHookArg(PartitionRelationId,
+								 RelationGetRelid(partRel), 0,
+								 RelationGetRelid(rel), false);
+
 	return address;
 }
 
@@ -14837,8 +15054,7 @@ ATExecAttachPartitionIdx(List **wqueue, Relation parentIdx, RangeVar *name)
 	ObjectAddressSet(address, RelationRelationId, RelationGetRelid(partIdx));
 
 	/* Silently do nothing if already in the right state */
-	currParent = partIdx->rd_rel->relispartition ?
-		get_partition_parent(partIdxId) : InvalidOid;
+	currParent = partIdx->rd_rel->relpartitionparent;
 	if (currParent != RelationGetRelid(parentIdx))
 	{
 		IndexInfo  *childInfo;
@@ -14932,7 +15148,7 @@ ATExecAttachPartitionIdx(List **wqueue, Relation parentIdx, RangeVar *name)
 		IndexSetParentIndex(partIdx, RelationGetRelid(parentIdx));
 		if (OidIsValid(constraintOid))
 			ConstraintSetParentConstraint(cldConstrId, constraintOid);
-		update_relispartition(NULL, partIdxId, true);
+		update_relpartitionparent(NULL, partIdxId, RelationGetRelid(parentIdx));
 
 		pfree(attmap);
 
@@ -15060,7 +15276,7 @@ validatePartitionedIndex(Relation partedIdx, Relation partedTbl)
 	 * If this index is in turn a partition of a larger index, validating it
 	 * might cause the parent to become valid also.  Try that.
 	 */
-	if (updated && partedIdx->rd_rel->relispartition)
+	if (updated && OidIsValid(RelationGetParentRelid(partedIdx)))
 	{
 		Oid			parentIdxId,
 					parentTblId;
@@ -15070,8 +15286,8 @@ validatePartitionedIndex(Relation partedIdx, Relation partedTbl)
 		/* make sure we see the validation we just did */
 		CommandCounterIncrement();
 
-		parentIdxId = get_partition_parent(RelationGetRelid(partedIdx));
-		parentTblId = get_partition_parent(RelationGetRelid(partedTbl));
+		parentIdxId = RelationGetParentRelid(partedIdx);
+		parentTblId = RelationGetParentRelid(partedTbl);
 		parentIdx = relation_open(parentIdxId, AccessExclusiveLock);
 		parentTbl = relation_open(parentTblId, AccessExclusiveLock);
 		Assert(!parentIdx->rd_index->indisvalid);
